CREATE TABLE IF NOT EXISTS `#__balances` (
  `MemberNo` int(11) NOT NULL,
  `CurrentBalance` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Dumping data for table `balances`
--


-- --------------------------------------------------------

--
-- Table structure for table `members`
--

CREATE TABLE IF NOT EXISTS `#__members` (
 `MemberId` int(11) NOT NULL AUTO_INCREMENT,
 `Number` int(11) NOT NULL,
 `Surname` varchar(100) DEFAULT NULL,
 `FirstName` varchar(100) NOT NULL,
 `TelNo` varchar(100) DEFAULT NULL,
 `Address` varchar(255) DEFAULT NULL,
 `Postcode` varchar(100) DEFAULT NULL,
 `Email` varchar(100) DEFAULT NULL,
 `JosId` int(11) NOT NULL,
 `Enabled` tinyint(4) NOT NULL DEFAULT '1',
 PRIMARY KEY (`MemberId`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8;


-- --------------------------------------------------------

--
-- Table structure for table `payments`
--

CREATE TABLE IF NOT EXISTS `#__payments` (
  `PayerId` int(11) NOT NULL,
  `PayeeId` int(11) NOT NULL,
  `Date` date NOT NULL,
  `Timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `Amount` int(11) NOT NULL,
  `Type` varchar(100) DEFAULT NULL,
  `Reference` varchar(1000) DEFAULT NULL,
  `PayerNewBalance` int(11) NOT NULL,
  `PayeeNewBalance` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Table structure for table `joomla_lets_map`
--

CREATE TABLE IF NOT EXISTS `#__joomla_lets_map` (
 `MemberNo` int(11) NOT NULL,
 `JosId` int(11) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Table structure for table `directory_category`
--

CREATE TABLE IF NOT EXISTS `#__directory_category` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `parentid` int(11) DEFAULT NULL,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Table structure for table `jos_directory_entry`
--

CREATE TABLE IF NOT EXISTS `#__directory_entry` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `MemberNo` int(11) NOT NULL,
  `CategoryId` int(11) NOT NULL,
  `Type` enum('Offer','Want') NOT NULL,
  `Description` varchar(4000) NOT NULL,
  `LastUpdated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `Rate` varchar(256) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

--
-- Table structure for table `historic_balances`
--

CREATE TABLE IF NOT EXISTS `#__historic_balances` (
  `Year` int(11) NOT NULL,
  `MemberNo` int(11) NOT NULL,
  `Balance1` int(11),
  `Trades1` int(11),
  `Balance2` int(11),
  `Trades2` int(11),
  `Balance3` int(11),
  `Trades3` int(11),
  `Balance4` int(11),
  `Trades4` int(11)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

