<?php
/**
 * @version		$Id: search.php 10752 2008-08-23 01:53:31Z eddieajau $
 * @package		Joomla
 * @subpackage	Search
 * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant to the
 * GNU General Public License, and as distributed it includes or is derivative
 * of works licensed under the GNU General Public License or other free or open
 * source software licenses. See COPYRIGHT.php for copyright notices and
 * details.
 */

// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

/**
 * Search Component Search Model
 *
 * @package		Joomla
 * @subpackage	Search
 * @since 1.5
 */
class letsformsModelaccounts extends JModel
{
	var $errorMsg;

	function transfer()
	{
		$from = JRequest::getVar('from');
		$to = JRequest::getVar('to');
		$amount = JRequest::getVar('amount');
		$type = JRequest::getVar('type');
		$reference = JRequest::getVar('reference');
		
		if(empty($amount)) {
			$error = "Unable to transfer funds from account $from. Reason: No amount was entered.";
			return $error;
		}
		
		$dbo =& JFactory::getDBO();
		$dbo->BeginTrans();
		
		$result = $this->lowerBalance($dbo, $from, $amount);
		if(!$result) {
			$errorMsg = $dbo->getErrorMsg();
			$dbo->RollbackTrans();
			$error = "Unable to transfer funds from account $from. Reason: $errorMsg.";
			return $error;
		}
		
		$result = $this->raiseBalance($dbo, $to, $amount);
		if(!$result) {
			$errorMsg = $dbo->getErrorMsg();
			$dbo->RollbackTrans();
			$error = "Unable to transfer funds to account $to. Reason: $errorMsg.";
			return $error;
		}
		
		$newFromBalance = $this->getBalance($dbo, $from);
		$newToBalance = $this->getBalance($dbo, $to);
		
		$result = $this->addPaymentDetails($dbo, $from, $to, $amount, $type, $reference, $newFromBalance, $newToBalance);
		if(!$result) {
			$errorMsg = $dbo->getErrorMsg();
			$dbo->RollbackTrans();
			$error = "Unable to add payment details for the transfer. Reason: $errorMsg.";
			return $error;
		}
		
		JRequest::setVar('balance', $newFromBalance);
		$dbo->CommitTrans();
		
		if(empty($error)) {
			$payer = $this->getNameFromMemberNo($from);
			$payee = $this->getNameFromMemberNo($to);
			
			$payerEmail = $this->getUserEmails($from);
			$payeeEmail = $this->getUserEmails($to);
		
			// Send a confirmation to the payer
			if(!empty($payerEmail)) {
				$this->sendPayerConfirmation($payerEmail, $payer, $payee, $amount, $newFromBalance);
			}
			
			// Send a confirmation to the payee
			if(!empty($payeeEmail)) {
				$this->sendPayeeConfirmation($payeeEmail, $payer, $payee, $amount, $newToBalance);
			}
		}		
                
		return $error;
	}
	
	function getCurrentBalance($memberNo) {
		$dbo =& JFactory::getDBO();
		$balance = $this->getBalance($dbo, $memberNo);
		
		return $balance;
	}
	
	function getBalance($dbo, $memberNo) {
		$query = "SELECT CurrentBalance FROM #__balances WHERE MemberNo = $memberNo";
		$dbo->setQuery($query);
		$result = $dbo->loadResult();
		
		return $result;
	}
	
	function raiseBalance($dbo, $memberNo, $amount) {
		$query = "UPDATE #__balances SET CurrentBalance = CurrentBalance + $amount WHERE MemberNo = $memberNo";
		$dbo->setQuery($query);
		$result = $dbo->query();
		
		if(!$result) {
			$errorMsg = $dbo->getErrorMsg();
		}
		
		return $result;
	}
	
	function lowerBalance($dbo, $memberNo, $amount) {
		$query = "UPDATE #__balances SET CurrentBalance = CurrentBalance - $amount WHERE MemberNo = $memberNo";
		$dbo->setQuery($query);
		$result = $dbo->query();
		
		if(!$result) {
			$errorMsg = $dbo->getErrorMsg();
		}
		
		return $result;
	}
	
	function addPaymentDetails($dbo, $from, $to, $amount, $type, $reference, $fromBalance, $toBalance) {
                $reference = mysql_real_escape_string($reference);

		$query = "INSERT INTO #__payments (PayerId, PayeeId, Date, Amount, Type, Reference, PayerNewBalance, PayeeNewBalance)"
                  	 . " VALUES ($from, $to, CURDATE(), $amount, '$type', '$reference', $fromBalance, $toBalance)";
                $dbo->setQuery($query);
                $result = $dbo->query();
		
		if(!$result) {
			$errorMsg = $dbo->getErrorMsg();
		}
		
		return $result;
	}
	
	function getPayments($memberNo, $period) {
		$dbo =& JFactory::getDBO();
		
		//var_dump($period);
		if($period == 'all') {
			$query = "SELECT * FROM #__payments WHERE PayerId = $memberNo OR PayeeId = $memberNo";
		}
		else {
			$day = 24 * 60 * 60;
			if($period == 'week') {
				$starttime = time() - (7 * $day);
			}
			else if($period == 'month') {
				$starttime = time() - (30 * $day);
			}
			else if($period == 'quarter') {
				$starttime = time() - (90 * $day);
			}
			
			$mysqldate = date('Y-m-d', $starttime);
			$query = "SELECT * FROM #__payments WHERE Date >= '$mysqldate' AND (PayerId = $memberNo OR PayeeId = $memberNo) ORDER BY Timestamp";
			//var_dump($query);
		}
		
            	$dbo->setQuery($query);
            	$result = $dbo->Query();
            	$count = $dbo->getNumRows();
            	$i = 0;
            	if($count > 0) {
                	$lines = $dbo->loadAssocList();
                	foreach($lines as $line) {
                		$mysqldate = $line['Date'];
                		$payment['date'] = date('d/n/y', strtotime($mysqldate));
                		
                		$payer = $line['PayerId'];
                		$payee = $line['PayeeId'];
                		$payerBalance = $line['PayerNewBalance'];
                		$payeeBalance = $line['PayeeNewBalance'];
                		$amount = $line['Amount'];
                		
                		if($memberNo == $payer) {
                			$payment['to'] = $this->getNameFromMemberNo($payee);
                			$payment['balance'] = $payerBalance;
                			$payment['out'] = $amount;
                			$payment['from'] = null;
                			$payment['in'] = null;		
                		}
                		else if($memberNo == $payee) {
                			$payment['from'] = $this->getNameFromMemberNo($payer);
                			$payment['balance'] = $payeeBalance;
                			$payment['in'] = $amount;
                			$payment['to'] = null;
                			$payment['out'] = null;
                		}
                		              		
                		$payment['type'] = $line['Type'];
                		$payment['reference'] = $line['Reference'];
	  			
	  			$payments[$i] = $payment;
	  	
	  			$i++;
                	}
                }
                
		return $payments;
	}
	
	function getMembersBalances($year) {
		$dbo =& JFactory::getDBO();
		
		$query = "SELECT b.MemberNo, jm.FirstName, jm.Surname, b.CurrentBalance"
		         . " FROM #__balances b, #__members jm WHERE jm.Number = b.MemberNo AND jm.FirstName NOT LIKE 'Test%'"
                         . " AND jm.Enabled > 0"
                         . " ORDER BY jm.Surname, jm.FirstName";

		//var_dump($query);
            	$dbo->setQuery($query);
            	$result = $dbo->Query();
            	$count = $dbo->getNumRows();
            	$i = 0;
            	if($count > 0) {
                	$lines = $dbo->loadAssocList();
                	foreach($lines as $line) {
                		$membalance['memberno'] = $line['MemberNo'];
  				$membalance['balance'] = $line['CurrentBalance']; 
  				
  				if(empty($line['FirstName'])) {
  					$membalance['name'] = $line['Surname'];
  				}	
  				else if(empty($line['Surname']))	{
  					$membalance['name'] = $line['FirstName'];
  				}	
  				else {
  					$membalance['name'] = $line['FirstName'] . ' ' . $line['Surname'];
  				}	
	  			
	  			$membalances[$i] = $membalance;
	  	
	  			$i++;
                	}
                }
		
		return $membalances;
	}
	
	function getBalanceData($dbo, $memberNo, $from, $to) {
		$query = "SELECT PayerId, PayeeId, PayerNewBalance, PayeeNewBalance FROM #__payments WHERE Date >= '$from' AND Date <= '$to' AND (PayerId = $memberNo OR PayeeId = $memberNo) ORDER BY Timestamp DESC";
		
		$dbo->setQuery($query);
            	$result = $dbo->Query() or die("Unable to get a listing of payments");
            	$count = $dbo->getNumRows();
            	
            	if($count > 0) {
            		$row = $dbo->loadRow();
            		$payerId = $row[0];
            		$payeeId = $row[1];
            		$payerBalance = $row[2];
            		$payeeBalance = $row[3];
            		
            		$balanceData['trades'] = $count;
            		if($payerId == $memberNo) {
            			$balanceData['balance'] = $payerBalance;
            		}
            		else if($payeeId == $memberNo) {
            			$balanceData['balance'] = $payeeBalance;
            		}
            	}
            	else {
            		// TODO: Actually this needs to get the previous balance in the payments table first before it looks
            		// at the current balance
            		$balanceData['trades'] = 0;
            		$balance = $this->getCurrentBalance($memberNo);
            		if(!empty($balance)) {
            			$balanceData['balance'] = $balance;
            		}
            		else {
            			$balanceData['balance'] = 0;
            		}
            	}
            	
            	return $balanceData;
	}
	
	function getNameFromMemberNo($memberNo)
	{
		$dbo =& JFactory::getDBO();
		$query = "SELECT FirstName, Surname FROM #__members WHERE Number = $memberNo";
            	$dbo->setQuery($query);
            	$row = $dbo->loadRow();
            	
            	$firstName = $row[0];
            	$surname = $row[1];
            	
            	if(empty($firstName)) {
            		$name = $surname;
            	}
            	else if(empty($surname)) {
            		$name = $firstName;
            	}
            	else {
            		$name = $firstName . ' ' . $surname;
            	}
                
		return $name;
	}
	
	function sendPayeeConfirmation($email, $payer, $payee, $transferAmount, $balance) {
		
		$subject = 'Nidderdale LETS: A payment has been made to your Nidds account';
		
		$body = "Hi $payee\n\n"
			. "A payment has been made to your Nidds account by $payer. \n\n"
		        . "The amount transferred to you was $transferAmount nidds.\n\n"
		        . "Your new balance is $balance nidds.\n\n"
		        . "If you want to query the transfer please contact me at:\n\n"
			. "nidds.treasurer@nidderdalelets.org.uk\n\n"
			. "Regards\n\n"
			. "Nidds Treasurer";
			
		$this->sendMail($email, $subject, $body);

	}
	
	function sendPayerConfirmation($email, $payer, $payee, $transferAmount, $balance) {
		
		$subject = 'Nidderdale LETS: A payment has been made from your Nidds account';
		
		$body = "Hi $payer\n\n"
			. "A payment has been made from your Nidds account to $payee. \n\n"
		        . "The amount transferred was $transferAmount nidds.\n\n"
		        . "Your new balance is $balance nidds.\n\n"
		        . "If you want to query the transfer please contact me at:\n\n"
			. "nidds.treasurer@nidderdalelets.org.uk\n\n"
			. "Regards\n\n"
			. "Nidds Treasurer";
			
		$this->sendMail($email, $subject, $body);

	}
	
	function sendMail($toAddress, $subject, $body) {
		$config		= &JFactory::getConfig();
		$from		= $config->getValue('mailfrom');
		$fromname	= $config->getValue('fromname');
		
		if (!JUtility::sendMail($from, $fromname, $toAddress, $subject, $body))
		{
			$error = "Error sending email";
		}
		
		return $error;
	}
	
	function getEmailString($memberNo) {
		$emails = $this->getUserEmails($memberNo);
			
		if(!empty($emails)) {
			$len = count($emails);
			$i = 1;
			foreach($emails as $email) {
				$emailstr = $emailstr . $email['email'];
				if($i < $len) {
					$emailstr = $emailstr . '; ';
				} 
				$i++;				
			}
			
			$emailstr = $emailstr;
		}
		
		return $emailstr;
	}

	function getUserEmails($memberNo)
	{
		$dbo =& JFactory::getDBO();
		$query = "SELECT ju.email FROM #__users ju, #__joomla_lets_map jjlm WHERE jjlm.MemberNo = $memberNo"
			 . " AND ju.id = jjlm.JosId AND ju.email IS NOT NULL AND ju.email != ''";
            	$dbo->setQuery($query);
            	$result = $dbo->Query();
            	$count = $dbo->getNumRows();
            	$i = 0;
            	if($count > 0) {
                	$lines = $dbo->loadAssocList();
                	foreach($lines as $line) {
	  			$emails[$i] = $line['email'];
	  			$i++;
                	}
                }
                
		return $emails;
	}
}
