<?php
/**
 * @version		$Id: search.php 10752 2008-08-23 01:53:31Z eddieajau $
 * @package		Joomla
 * @subpackage	Search
 * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant to the
 * GNU General Public License, and as distributed it includes or is derivative
 * of works licensed under the GNU General Public License or other free or open
 * source software licenses. See COPYRIGHT.php for copyright notices and
 * details.
 */

// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');
jimport('joomla.error.log');

/**
 * Search Component Search Model
 *
 * @package		Joomla
 * @subpackage	Search
 * @since 1.5
 */
class letsformsModelmembers extends JModel
{
	function getMembers()
	{
		$dbo =& JFactory::getDBO();
		$query = "SELECT * FROM #__members WHERE Enabled > 0 ORDER BY Surname, FirstName";
            	$dbo->setQuery($query);
            	$result = $dbo->Query();
            	$count = $dbo->getNumRows();
            	$i = 0;
            	if($count > 0) {
                	$lines = $dbo->loadAssocList();
                	foreach($lines as $line) {
                		$name = (is_null($line['Surname'])) ? $line['FirstName'] : $line['FirstName'] . " " . $line['Surname'];
	  			$member['id'] = $line['MemberId'];
	  			$member['number'] = $line['Number'];
	  			$member['name'] = $name;
	  			$member['address'] = $line['Address'];
	  			$member['postcode'] = $line['Postcode'];
	  			$member['telno'] = $line['TelNo'];
	  			$member['email'] = $line['Email'];
	  			
	  			$members[$i] = $member;
	  	
	  			$i++;
                	}
                }
                
		return $members;
	}
	
	function getMembersWithoutCurrentUser()
	{
		$user =& JFactory::getUser();
		$memberNo = $this->getMemberNoFromUserId($user->id);
		
		$dbo =& JFactory::getDBO();
		if(!is_null($memberNo)) {
			$query = "SELECT * FROM #__members WHERE Number != $memberNo AND Enabled > 0 ORDER BY Surname, FirstName";
		}
		else {
			$query = "SELECT * FROM #__members WHERE Enabled > 0 ORDER BY Surname, FirstName";
		}
            	$dbo->setQuery($query);
            	$result = $dbo->Query();
            	$count = $dbo->getNumRows();
            	$i = 0;
            	if($count > 0) {
                	$lines = $dbo->loadAssocList();
                	foreach($lines as $line) {
                		$name = (is_null($line['Surname'])) ? $line['FirstName'] : $line['FirstName'] . " " . $line['Surname'];
	  			$member['id'] = $line['MemberId'];
	  			$member['number'] = $line['Number'];
	  			$member['name'] = $name;
	  			$member['address'] = $line['Address'];
	  			$member['postcode'] = $line['Postcode'];
	  			$member['telno'] = $line['TelNo'];
	  			$member['email'] = $line['Email'];
	  			
	  			$members[$i] = $member;
	  	
	  			$i++;
                	}
                }

		return $members;
	}
	
	function getMemberDetails($memberNo)
	{
		$dbo =& JFactory::getDBO();
		$query = "SELECT FirstName, Surname, Number, Address, TelNo, Postcode, Email FROM #__members WHERE Number = $memberNo";
            	$dbo->setQuery($query);
            	$row = $dbo->loadRow();
            	
            	$member['firstname'] = $row[0];
            	$member['surname'] = $row[1];
            	
            	if(empty($member['firstname'])) {
            		$member['name'] = $member['surname'];
            	}
            	else if(empty($member['surname'])) {
            		$member['name'] = $member['firstname'];
            	}
            	else {
            		$member['name'] = $member['firstname'] . ' ' . $member['surname'];
            	}
            	
            	$member['memberNo'] = $row[2];
            	$member['address'] = $row[3];
            	$member['telno'] = $row[4];
            	$member['postcode'] = $row[5];
            	$member['email'] = $row[6];
            	
		return $member;
	}
	
	function getCategories()
	{
		$dbo =& JFactory::getDBO();
		$query = "SELECT * FROM #__directory_category";
            	$dbo->setQuery($query);
            	$result = $dbo->Query();
            	$count = $dbo->getNumRows();
            	$i = 0;
            	if($count > 0) {
                	$lines = $dbo->loadAssocList();
                	foreach($lines as $line) {
	  			$category['id'] = $line['id'];
	  			$category['parentid'] = $line['parentid'];
	  			$category['name'] = $line['name'];
	  			
	  			$categories[$i] = $category;
	  	
	  			$i++;
                	}
                }
                
		return $categories;
	}
	
	function getUserEmails($memberNo)
	{
		$dbo =& JFactory::getDBO();
		$query = "SELECT ju.email FROM #__users ju, #__joomla_lets_map jjlm WHERE jjlm.MemberNo = $memberNo"
			 . " AND ju.id = jjlm.JosId AND ju.email IS NOT NULL AND ju.email != ''";
            	$dbo->setQuery($query);
            	$result = $dbo->Query();
            	$count = $dbo->getNumRows();
            	$i = 0;
            	if($count > 0) {
                	$lines = $dbo->loadAssocList();
                	foreach($lines as $line) {
	  			$email['email'] = $line['email'];
	  			
	  			$emails[$i] = $email;
	  	
	  			$i++;
                	}
                }
                
		return $emails;
	}
	
	function getMemberNoFromUserId($userId) {
		$dbo =& JFactory::getDBO();
		$query = "SELECT MemberNo FROM #__joomla_lets_map WHERE JosId = $userId";
		$dbo->setQuery($query);
		$result = $dbo->loadResult();
		
		return $result;
	}
	
	function getNameFromMemberNo($memberNo)
	{
		$dbo =& JFactory::getDBO();
		$query = "SELECT FirstName, Surname FROM #__members WHERE Number = $memberNo";
            	$dbo->setQuery($query);
            	$row = $dbo->loadRow();
            	
            	$firstName = $row[0];
            	$surname = $row[1];
            	
            	if(empty($firstName)) {
            		$name = $surname;
            	}
            	else if(empty($surname)) {
            		$name = $firstName;
            	}
            	else {
            		$name = $firstName . ' ' . $surname;
            	}
                
		return $name;
	}
	
	function getCategoryName($categoryId) {
		$dbo =& JFactory::getDBO();
		$query = "SELECT name FROM #__directory_category WHERE id = $categoryId";
		$dbo->setQuery($query);
		$result = $dbo->loadResult();
		
		return $result;
	}
	
	function register() {
		$file = JRequest::getVar('fileUploader', '', 'files', 'array');
		//var_dump($file);
		
		if(!empty($file['name'])) {
			$error = $this->registerBulk($file);
		}
		else {
			$array['firstName'] = JRequest::getVar('firstname');
			$array['surname'] = JRequest::getVar('surname');
			$array['username'] = JRequest::getVar('username');
			$array['password'] = JRequest::getVar('password');
			$array['password2'] = JRequest::getVar('confirmpass');
			$array['email'] = JRequest::getVar('email');
			$array['memberNo'] = JRequest::getVar('number');
			$array['address'] = JRequest::getVar('address');
			$array['postcode'] = JRequest::getVar('postcode');
			$array['telno'] = JRequest::getVar('telno');
			
			$error = $this->registerSingle($array);
		}
	}
	
	function registerBulk($file) {
		$log = &JLog::getInstance('com_letsforms.log.php');
	
		// First we need to upload the file
		jimport('joomla.filesystem.file');
 
		//Clean up filename to get rid of strange characters like spaces etc
		$filename = JFile::makeSafe($file['name']);
		
		$log->addEntry(array('comment' => $file['name']));
 
		//Set up the source and destination of the file
		$src = $file['tmp_name'];
		$dest = JPATH_COMPONENT . DS . 'uploads' . DS . $filename;
		
		$log->addEntry(array('comment' => 'Src: ' . $src));
		$log->addEntry(array('comment' => 'Dest: ' . $dest));
		
		if (!JFile::upload($src, $dest))
		{
			$error = "Upload failed, check to make sure that /components/com_letsforms/uploads exists and is writable.";
			return $error;
		}
		
		// Now read the file and process it
		$fp = fopen($dest, "r");
		//Output a line of the file until the end is reached
		while(!feof($fp))
  		{
  			$line = fgets($fp);
  			$array = explode("\t", $line);
  			if(count($array) == 10) {
  				$error = $this->processRegistrationEntry($array);
  			}
  		}
		fclose($fp);
		
		return $error;
	}
	
	function processRegistrationEntry($entry) {
		$array['firstName'] = $entry[0];
		$array['surname'] = $entry[1];
		$array['username'] = $entry[2];
		$array['password'] = $entry[3];
		$array['password2'] = $array['password'];
		$array['email'] = $entry[4];
		$array['memberNo'] = $entry[5];
		$array['address'] = $entry[6];
		$array['postcode'] = $entry[7];
		$array['telno'] = $entry[8];
		$array['altFirstName'] = chop($entry[9]);
		
		$error = $this->registerSingle($array);
		return $error;
	}
	
	function registerSingle($array) {
		$firstName = $array['firstName'];
		$surname = $array['surname'];
		$username = $array['username'];
		$password = $array['password'];
		$password2 = $array['password2'];
		$email = $array['email'];
		$memberNo = $array['memberNo'];
		$address = $array['address'];
		$postcode = $array['postcode'];
		$telno = $array['telno'];
		
		// This is the display name for the Joomla account, so it needs to
		// be the individual's name rather than the Lets account name.
		if(empty($firstName)) {
			$name = $surname;
		}
		else if(empty($surname)) {
			$name = $firstName;
		}
		else {
			$name = $firstName . ' ' . $surname;
		}
		
		// This is for members who have more than one online account. The alternative 
		// first name and surname are the names on the Lets account.
		if(!empty($array['altFirstName'])) {
			$firstName = $array['altFirstName'];
		}
		
		/* We need to get an empty JUser object and bind it with an array containing values for:
		       	'name'
	           	'username'
	           	'password'
	           	'password2'  
	           	'email'
		*/
		$id = $this->registerSave($name, $username, $password, $password2, $email);
		
		/* Then we need to insert a record into the LETS members table (#__members). The JUser
		   object we created earlier will contain the jos_id after the bind. For new members we'll 
		   have to generate a Membership No.  
		*/
		
		if($id > 0) {
			$error = $this->addLetsMember($firstName, $surname, $email, $memberNo, $address, $postcode, $telno, $id);
		}
	}
	
	function registerSave($name, $username, $password, $password2, $email) {
		/* Code copied from com_user controller.php. 
		*/
		global $mainframe;

		// Get required system objects
		$user 		= clone(JFactory::getUser());
		$pathway 	=& $mainframe->getPathway();
		$config		=& JFactory::getConfig();
		$authorize	=& JFactory::getACL();
		$document   =& JFactory::getDocument();

		// If user registration is not allowed, show 403 not authorized.
		$usersConfig = &JComponentHelper::getParams( 'com_users' );
		if ($usersConfig->get('allowUserRegistration') == '0') {
			JError::raiseError( 403, JText::_( 'Access Forbidden' ));
			return 0;
		}

		// Initialize new usertype setting
		$newUsertype = $usersConfig->get( 'new_usertype' );
		if (!$newUsertype) {
			$newUsertype = 'Registered';
		}
		
		$array['name'] = $name;
		$array['username'] = $username;
		$array['password'] = $password;
		$array['password2'] = $password2;
		$array['email'] = $email;

		// Bind the post array to the user object
		if (!$user->bind( $array, 'usertype' )) {
			JError::raiseError( 500, $user->getError());
		}

		// Set some initial user values
		$user->set('id', 0);
		$user->set('usertype', $newUsertype);
		$user->set('gid', $authorize->get_group_id( '', $newUsertype, 'ARO' ));

		$date =& JFactory::getDate();
		$user->set('registerDate', $date->toMySQL());

		// If user activation is turned on, we need to set the activation information
		/*$useractivation = $usersConfig->get( 'useractivation' );
		if ($useractivation == '1')
		{
			jimport('joomla.user.helper');
			$user->set('activation', JUtility::getHash( JUserHelper::genRandomPassword()) );
			$user->set('block', '1');
		}*/

		// If there was an error with registration, set the message and display form
		if ( !$user->save() )
		{
			JError::raiseWarning('', JText::_( $user->getError()));
			//$this->register();
	                return 0;
		}
		
		// Send registration confirmation mail
		$this->sendRegistrationConfirmation($array['email'], $array['name'], $array['username'], $password );
		
		return $user->id;

	}
	
	function sendRegistrationConfirmation($email, $name, $username, $password) {
		// Send registration confirmation mail
		$password = preg_replace('/[\x00-\x1F\x7F]/', '', $password); //Disallow control chars in the email
		
		$subject = 'Nidderdale LETS Registration Confirmation';
		
		$body = "Hi $name\n\n"
			. "Welcome to Nidderdale LETS!.\n\n"
		        . "You have been registered as a new member on the Nidderdale LETS website."
		        . " To login, enter the following address in the navigation bar of your browser:\n\n"
		        . "http://nidderdalelets.org.uk\n\n"
		        . "Your login details are as follows:\n\n"
		        . "Username: $username\n"
		        . "Password: $password\n\n"
		        . "If you find any problems, or have any suggestions, please contact me at the following address:\n\n"
			. "webmaster@nidderdalelets.org.uk\n\n"
			. "Regards\n\n"
			. "Nidderdale LETS";
			
		$this->sendMail($email, $subject, $body);

	}
	
	function addLetsMember($firstName, $surname, $email, $memberNo, $address, $postcode, $telno, $id) {
		$dbo =& JFactory::getDBO();
		
		// The member may have more than one online account, so just add a new mapping
		if($this->memberExists($dbo, $memberNo)) {
			$this->addNewJosAccount($dbo, $memberNo, $id);
			return $result;
		}
	
		if(empty($memberNo)) {
			$memberNo = $this->getNextMemberNo($dbo);
		}
		
		$surname = mysql_real_escape_string($surname);
		$firstName = mysql_real_escape_string($firstName);
		$address = mysql_real_escape_string($address);
		$query = "INSERT INTO #__members (Number, Surname, FirstName, TelNo, Address, Postcode, Email, JosId)"
                  	 . " VALUES ($memberNo, '$surname', '$firstName', '$telno', '$address', '$postcode', '$email', $id)";
                $dbo->setQuery($query);
                $result = $dbo->query();
		
		if(!$result) {
			$error = $dbo->getErrorMsg();
		}
		else {
			$error = $this->addNewMemberBalance($dbo, $memberNo);
			if(empty($error)) {
				$error = $this->addNewJosAccount($dbo, $memberNo, $id);
			}
		}
		
		return $error;
	}
	
	function editMember() {
		// Save the Joomla username and email, if necessary
		$user =& JFactory::getUser();
		$username = JRequest::getVar('username');
		$email = JRequest::getVar('email');
		$requireChange = false;
		if($user->username != $username || $user->email != $email) {
			if($user->username != $username && !empty($username)) {
				$requireChange = true;
				$user->username = $username;
			}
			
			if($user->email != $email && !empty($email)) {
				$requireChange = true;
				$user->email = $email;
			}
			
			if($requireChange && !$user->save() )
			{
				return JText::_( $user->getError());
			}	
		}
	
		$dbo =& JFactory::getDBO();
		
		$firstname = JRequest::getVar('firstname');
		$surname = JRequest::getVar('surname');
		
		$memberNo = JRequest::getVar('memberNo');
		$address = JRequest::getVar('address');
		$postcode = JRequest::getVar('postcode');
		$telno = JRequest::getVar('telno');
		
		$surname = mysql_real_escape_string($surname);
		$firstName = mysql_real_escape_string($firstName);
		$address = mysql_real_escape_string($address);
		$query = "UPDATE #__members SET Surname = '$surname', FirstName = '$firstname', TelNo = '$telno', Address = '$address',"
                  	 . " Postcode = '$postcode' WHERE Number = $memberNo";
                $dbo->setQuery($query);
                $result = $dbo->query();
		
		if(!$result) {
			return $dbo->getErrorMsg();
		}
	}
	
	function getNextMemberNo($dbo) {
		$query = "SELECT MAX(Number) FROM #__members";
		$dbo->setQuery($query);
		$result = $dbo->loadResult();
		$result += 1;
		
		return $result;
	}
	
	function memberExists($dbo, $memberNo) {
		$query = "SELECT COUNT(Number) FROM #__members WHERE Number = $memberNo";
		$dbo->setQuery($query);
		$result = $dbo->loadResult();
		
		return $result;
	}
	
	function addNewMemberBalance($dbo, $memberNo) {
		$query = "INSERT INTO #__balances (MemberNo, CurrentBalance)"
                  	 . " VALUES ($memberNo, 10)";
                $dbo->setQuery($query);
                $result = $dbo->query();
		
		if(!$result) {
			$errorMsg = $dbo->getErrorMsg();
		}
		
		return $errorMsg;
	}
	
	function addNewJosAccount($dbo, $memberNo, $id) {
		$query = "INSERT INTO #__joomla_lets_map (MemberNo, JosId)"
                  	 . " VALUES ($memberNo, $id)";
                $dbo->setQuery($query);
                $result = $dbo->query();
		
		if(!$result) {
			$errorMsg = $dbo->getErrorMsg();
		}
		
		return $errorMsg;
	}
	
	// Copied from com_user/model/reset.php
	function changePassword()
	{
		jimport('joomla.user.helper');

		global $mainframe;
		
		$password1 = JRequest::getVar('password');
		$password2 = JRequest::getVar('confirmpass');

		// Make sure that we have a pasword
		if(empty($password1))
		{
			$error = "Please enter a password";
			return $error;
		}
		
		// Verify that the passwords match
		if($password1 != $password2)
		{
			$error = "The passwords do not match. Please try again.";
			return $error;
		}

		// Get the necessary variables
		$db		= &JFactory::getDBO();
		$user 		= &JFactory::getUser();
		$id		= $user->id;
		$salt		= JUserHelper::genRandomPassword(32);
		$crypt		= JUserHelper::getCryptedPassword($password1, $salt);
		$password	= $crypt.':'.$salt;

		//var_dump($password1);
		//var_dump($password);

		// Build the query
		$query 	= 'UPDATE #__users'
				. ' SET password = '.$db->Quote($password)
				. ' WHERE id = ' . $id;
				
		//var_dump($query);

		$db->setQuery($query);

		// Save the password
		if (!$result = $db->query())
		{
			$error = $db->getErrorMsg();
			return $error;
		}

		// Update the user object with the new values.
		$user->password		= $password;
		$user->password_clear	= $password1;

		return $error;
	}
	
	function addDirectoryEntry() {
		$file = JRequest::getVar('fileUploader', '', 'files', 'array');
		
		if(!empty($file['name'])) {
			$error = $this->addMultipleEntries($file);
		}
		else {
			$array['memberNo'] = JRequest::getVar('member');
			if(empty($array['memberNo'])) {
				$array['memberNo'] = JRequest::getVar('memberNo');
			}
			
			$array['categoryId'] = JRequest::getVar('category');
			$array['type'] = JRequest::getVar('offerorwant');
			$array['description'] = JRequest::getVar('description');
			$array['rate'] = JRequest::getVar('rate');
			
			$mode = JRequest::getVar('mode');
			if($mode == 'edit') {
				$array['id'] = JRequest::getVar('dirId');
			}

			$error = $this->updateSingleEntry($array, $mode);
		}
		
		return $error;
	}
	
	function addMultipleEntries($file) {
		// First we need to upload the file
		jimport('joomla.filesystem.file');
	
		//Clean up filename to get rid of strange characters like spaces etc
		$filename = JFile::makeSafe($file['name']);
 
		//Set up the source and destination of the file
		$src = $file['tmp_name'];
		$dest = JPATH_COMPONENT . DS . 'uploads' . DS . $filename;
		
		if (!JFile::upload($src, $dest))
		{
			$error = "Upload failed, check to make sure that /components/com_letsforms/uploads exists and is writable.";
			return $error;
		}
		
		// Now read the file and process it
		$fp = fopen($dest, "r");
		//Output a line of the file until the end is reached
		while(!feof($fp))
  		{
  			$line = fgets($fp);
  			$array = explode("\t", $line);
  			if(count($array) == 4 || count($array) == 5) {
  				$error = $this->processDirectoryEntry($array);
  			}
  		}
		fclose($fp);
		
		return $error;
	}
	
	function processDirectoryEntry($entry) {
		$array['memberNo'] = $entry[0];
		$array['categoryId'] = $entry[1];
		$array['type'] = $entry[2];
		$array['description'] = $entry[3];
		
		if(count($array) == 5) {
			$array['rate'] = $entry[4];
		}
				
		$error = $this->updateSingleEntry($array, 'add');
		return $error;
	}
	
	function updateSingleEntry($array, $mode) {
		$categoryId = $array['categoryId'];
		$type = $array['type'];
		$description = $array['description'];
		$rate = $array['rate'];
				
		if(empty($description)) {
			$error = 'You must supply a description for the directory entry';
			return $error;
		}
		
		if(empty($rate)) {
			$rate = 'NA';
		}
		
		if($mode == 'edit') {
			$id = $array['id'];
			$error = $this->updateDirectoryEntry($id, $categoryId, $type, $description, $rate);
		}
		else {
			$memberNo = $array['memberNo'];
			$error = $this->insertDirectoryEntry($memberNo, $categoryId, $type, $description, $rate);
		}
		
		return $error;
	}
	
	function insertDirectoryEntry($memberNo, $categoryId, $type, $description, $rate) {
		$dbo =& JFactory::getDBO();
		
		$description = mysql_real_escape_string($description);
		$rate = mysql_real_escape_string($rate);
		
		$query = "INSERT INTO #__directory_entry (MemberNo, CategoryId, Type, Description, Rate)"
                  	 . " VALUES ($memberNo, $categoryId, '$type', '$description', '$rate')";
                $dbo->setQuery($query);
                $result = $dbo->query();
		
		if(!$result) {
			$error = $dbo->getErrorMsg();
		}
	
		return $error;
	}
	
	function updateDirectoryEntry($id, $categoryId, $type, $description, $rate) {
		$dbo =& JFactory::getDBO();
		
		$description = mysql_real_escape_string($description);
		$rate = mysql_real_escape_string($rate);
		$mysqldate = date('Y-m-d', time());
		
		$query = "UPDATE #__directory_entry SET CategoryId = $categoryId, Type = '$type', Description = '$description',"
                  	 . " Rate = '$rate', LastUpdated = '$mysqldate' WHERE id =$id";
                $dbo->setQuery($query);
                $result = $dbo->query();
		
		if(!$result) {
			$error = $dbo->getErrorMsg();
		}
	
		return $error;
	}
	
	function getMatchingDirectoryEntries($categoryId, $offerorwant, $description, $period) {
		$dbo =& JFactory::getDBO();
		$query = $this->getSelectForDirectorySearch($categoryId, $offerorwant, $description, $period);
		//var_dump($query);
            	$dbo->setQuery($query);
            	$result = $dbo->Query();
            	$count = $dbo->getNumRows();
            	$i = 0;
            	if($count > 0) {
                	$lines = $dbo->loadAssocList();
                	foreach($lines as $line) {
                		$direntry['name'] = (is_null($line['FirstName'])) ? $line['Surname'] : $line['FirstName'] . " " . $line['Surname'];
                		$direntry['memberNo'] = $line['MemberNo'];
	  			$direntry['categoryName'] = $line['CategoryName'];
	  			$direntry['description'] = $line['Description'];
	  			$direntry['rate'] = $line['Rate'];
	  			$direntry['lastUpdated'] = date('d/n/y', strtotime($line['LastUpdated']));
	  			
	  			$direntries[$i] = $direntry;
	  	
	  			$i++;
                	}
                }
                
		return $direntries;
	}
	
	function getMemberEntries($memberNo, $offerorwant) {
		$dbo =& JFactory::getDBO();
		$query = $this->getSelectForMemberEntries($memberNo, $offerorwant);
		//var_dump($query);
            	$dbo->setQuery($query);
            	$result = $dbo->Query();
            	$count = $dbo->getNumRows();
            	$i = 0;
            	if($count > 0) {
                	$lines = $dbo->loadAssocList();
                	foreach($lines as $line) {
                		$direntry['id'] = $line['id'];
	  			$direntry['category'] = $line['CategoryName'];
	  			$direntry['description'] = $line['Description'];
	  			$direntry['rate'] = $line['Rate'];
	  			$direntry['lastUpdated'] = date('d/n/y', strtotime($line['LastUpdated']));
	  			
	  			$direntries[$i] = $direntry;
	  	
	  			$i++;
                	}
                }
                
                //var_dump($direntries);
                
		return $direntries;
	}
	
	function getSelectForDirectorySearch($categoryId, $offerorwant, $description, $period) {
		$query = "SELECT m.FirstName AS FirstName, m.Surname AS Surname, dc.name AS CategoryName, de.* FROM #__directory_entry de, #__members m, #__directory_category dc"
		         . " WHERE de.Type = '$offerorwant' AND m.Number = de.MemberNo AND dc.id = de.CategoryId AND m.Enabled > 0";
		         
		if(!empty($categoryId)) {
			$query = $query . " AND de.CategoryId = $categoryId";
		}
		
		if(!empty($description)) {
			$query = $query . " AND de.Description LIKE '%$description%'";
		}
		
		if($period != 'all') {
			$day = 24 * 60 * 60;
			if($period == 'week') {
				$starttime = time() - (7 * $day);
			}
			else if($period == 'month') {
				$starttime = time() - (30 * $day);
			}
			else if($period == 'quarter') {
				$starttime = time() - (90 * $day);
			}
			
			$mysqldate = date('Y-m-d', $starttime);
			$query = $query . " AND de.LastUpdated >= '$mysqldate'";
		}
		
		$query = $query . " ORDER BY CategoryName, Description, Surname, FirstName";
		
		return $query;
	}
	
	function getSelectForMemberEntries($memberNo, $offerorwant) {
		$query = "SELECT dc.name AS CategoryName, de.* FROM #__directory_entry de, #__directory_category dc"
		         . " WHERE de.CategoryId = dc.id AND de.MemberNo=$memberNo";
		         
		if(!empty($offerorwant)) {
			$query = $query . " AND de.Type = '$offerorwant'";
		}
		
		$query = $query . " ORDER BY CategoryName, Description";
		
		return $query;
	}
	
	function getDirectoryEntry($id)
	{
		$dbo =& JFactory::getDBO();
		$query = "SELECT id, MemberNo, CategoryId, Type, Description, Rate, LastUpdated FROM #__directory_entry WHERE id = $id";
            	$dbo->setQuery($query);
            	$row = $dbo->loadRow();
            	
            	$direntry['id'] = $row[0];
            	$direntry['memberNo'] = $row[1];
            	$direntry['categoryId'] = $row[2];
            	$direntry['type'] = $row[3];
            	$direntry['description'] = $row[4];
            	$direntry['rate'] = $row[5];
            	$direntry['lastUpdated'] = date('d/n/y', strtotime($row[6]));
            	
            	return $direntry;
	}
	
	function getSelectedEntries($selected) {
		$dbo =& JFactory::getDBO();
		$inClause = join(",", $selected);
		$query = "SELECT de.id, de.MemberNo, de.CategoryId, dc.Name, de.Type, de.Description, de.Rate, de.LastUpdated"
		         . " FROM #__directory_entry de, #__directory_category dc WHERE de.id IN ($inClause) AND de.CategoryId = dc.id"
		         . " ORDER BY dc.Name, de.Description";
		//var_dump($query);
            	$dbo->setQuery($query);
            	$result = $dbo->Query();
            	$count = $dbo->getNumRows();
            	$i = 0;
            	if($count > 0) {
                	$lines = $dbo->loadAssocList();
                	foreach($lines as $line) {
	  			$direntry['id'] = $line['id'];
            			$direntry['memberNo'] = $line['MemberNo'];
            			$direntry['categoryId'] = $line['CategoryId'];
            			$direntry['category'] = $line['Name'];
            			$direntry['type'] = $line['Type'];
            			$direntry['description'] = $line['Description'];
            			$direntry['rate'] = $line['Rate'];
            			$direntry['lastUpdated'] = date('d/n/y', strtotime($line['LastUpdated']));
	  			
	  			$direntries[$i] = $direntry;
	  	
	  			$i++;
                	}
                }
                
		return $direntries;
	}
	
	function deleteEntries() {
		$dbo =& JFactory::getDBO();
		
		$selected = JRequest::getVar('selected');
		
		$inClause = join(",", $selected);
		$query = "DELETE FROM #__directory_entry WHERE id IN ($inClause)";

		//var_dump($query);
            	$dbo->setQuery($query);
                $result = $dbo->query();
		
		if(!$result) {
			$error = $dbo->getErrorMsg();
		}
	
		return $error;
	}
	
	function mailMembers()
	{
		$config		= &JFactory::getConfig();
		//$uri		= &JFactory::getURI();
		//$url		= JURI::base().'index.php?option=com_user&view=reset&layout=confirm';
		//$sitename	= $config->getValue('sitename');
		
		// Set the e-mail parameters
		$from		= $config->getValue('mailfrom');
		$fromname	= $config->getValue('fromname');
		$subject	= JRequest::getVar('subject');
		$body		= JRequest::getVar('body');

		$members = $this->getActiveMembersWithEmails();
		foreach($members as $member) {
			
			$email 	= $member['email'];
			$name = $member['name'];
			$username = $member['username'];
			$nameparts = explode(" ", $name);
			$firstname = $nameparts[0];
			
			$mybody = $this->personaliseMessage($body, $firstname, $username);
	
			// Send the e-mail
			if (!JUtility::sendMail($from, $fromname, $email, $subject, $mybody))
			{
				$error = "Error sending email";
			}
		}

		return $error;
	}
	
	function sendMail($toAddress, $subject, $body) {
		$config		= &JFactory::getConfig();
		$from		= $config->getValue('mailfrom');
		$fromname	= $config->getValue('fromname');
		
		if (!JUtility::sendMail($from, $fromname, $toAddress, $subject, $body))
		{
			$error = "Error sending email";
		}
		
		return $error;
	}
	
	function getActiveMembersWithEmails() {
		$dbo =& JFactory::getDBO();
		$query = "SELECT name, username, email FROM jos_users" 
			 . " WHERE block = 0 AND email IS NOT NULL AND email != ''"
			 . " AND EXISTS (SELECT 'x' FROM jos_joomla_lets_map WHERE josid =id)";
			 
            	$dbo->setQuery($query);
            	$result = $dbo->Query();
            	$count = $dbo->getNumRows();
            	$i = 0;
            	if($count > 0) {
                	$lines = $dbo->loadAssocList();
                	foreach($lines as $line) {
	  			$member['name'] = $line['name'];
	  			$member['username'] = $line['username'];
	  			$member['email'] = $line['email'];
	  			
	  			$members[$i] = $member;
	  	
	  			$i++;
                	}
                }
                
		return $members;
	
	}
	
	function personaliseMessage($body, $firstname, $username) {
		$search = array("{FirstName}", "{LoginName}");
		$replace = array($firstname, $username);
		
		$mymessage = str_replace($search, $replace, $body);
		
		return $mymessage;
	}
}
