<?php
/**
 * @version		$Id: view.html.php 11646 2009-03-01 19:34:56Z ian $
 * @package		Joomla
 * @subpackage	Weblinks
 * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the Accounts task of the LetsForms component
 *
 * @static
 * @package		Joomla
 * @subpackage	LetsForms
 * @since 1.0
 */
class letsformsViewaccounts extends JView
{
	function display($tpl = null)
	{
		$layout     = JRequest::getCmd('layout');
		$itemid     = JRequest::getCmd('Itemid');
		
		if($layout == 'form') {
			$user =& JFactory::getUser();
			$user =& JFactory::getUser();
			$model =&$this->getModel('members');
			
			$params = &JComponentHelper::getParams('com_letsforms');
			
			$accessLevel = JRequest::getVar('accessLevel');
			if(empty($accessLevel)) {
				$accessLevel = $params->get('transferaccesslevel');
			}
			
			$currency = $params->get('currency');
			if(!empty($currency)) {
				$currency = $currency . "s";
			}
			
			$members = $model->getMembersWithoutCurrentUser();
			
			if($accessLevel == 'admin') {
				$from = JRequest::getVar('from');
			}
			
			$to = JRequest::getVar('to');
	
			$this->assignRef('members', $members);
			$this->assignRef('user', $user);
			$this->assignRef('accessLevel', $accessLevel);
			$this->assignRef('currency', $currency);
			
			$this->assignRef('errmsg', JRequest::getVar('errmsg'));
			$this->assignRef('from', $from);
			$this->assignRef('to', $to);
			$this->assignRef('amount', JRequest::getVar('amount'));
			$this->assignRef('type', JRequest::getVar('type'));
			$this->assignRef('reference', JRequest::getVar('reference'));
			
			$memberNo = $model->getMemberNoFromUserId($user->id);
			$this->assignRef('memberNo', $memberNo);
		}
		else if($layout == 'confirm') {
			$accessLevel = JRequest::getVar('accessLevel');
			
			if($accessLevel == 'admin') {
				$from = JRequest::getVar('from');
			}
			else {
				$from = JRequest::getVar('memberNo');
			}
			
			$to = JRequest::getVar('to');
			
			$model =&$this->getModel('members');
			$fromName = $model->getNameFromMemberNo($from);
			$toName = $model->getNameFromMemberNo($to);
			
			$this->assignRef('from', $from);
			$this->assignRef('to', $to);
			$this->assignRef('fromName', $fromName);
			$this->assignRef('toName', $toName);
			$this->assignRef('amount', JRequest::getVar('amount'));
			$this->assignRef('type', JRequest::getVar('type'));
			$this->assignRef('reference', JRequest::getVar('reference'));
			$this->assignRef('accessLevel', $accessLevel);
		}
		else if($layout == 'results') {
			$this->assignRef('amount', JRequest::getVar('amount'));
			$this->assignRef('balance', JRequest::getVar('balance'));
			
		}
		else if($layout == 'statement') {
			$period = JRequest::getVar('period');
			if(empty($period)) {
				$period = 'all';
			}
			
			$user =& JFactory::getUser();
			$mModel =&$this->getModel('members');
			$aModel =&$this->getModel('accounts');
			$memberNo = $mModel->getMemberNoFromUserId($user->id);
			
			$currentBalance = $aModel->getCurrentBalance($memberNo);
			$payments = $aModel->getPayments($memberNo, $period);
		
			$this->assignRef('period', $period);
			$this->assignRef('payments', $payments);
			$this->assignRef('balance', $currentBalance);
			
		}
		else if($layout == 'balances') {
			$year = JRequest::getVar('year');
			if(empty($year)) {
				$year = '2010';
			}
			
			//$mModel =&$this->getModel('members');
			$aModel =&$this->getModel('accounts');
			
			$membalances = $aModel->getMembersBalances($year);
			
			$this->assignRef('year', $year);
			$this->assignRef('membalances', $membalances);
		}
		else if($layout == 'error') {
			$this->assignRef('errmsg', JRequest::getVar('errmsg'));
		}
		
		$this->assignRef('Itemid', $itemid);

		parent::display($tpl);
	}

}
