<?php
/**
 * @version		$Id: view.html.php 11646 2009-03-01 19:34:56Z ian $
 * @package		Joomla
 * @subpackage	Weblinks
 * @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );

jimport( 'joomla.application.component.view');
jimport('joomla.error.log');

/**
 * HTML View class for the ListMembers task of the LetsForms component
 *
 * @static
 * @package		Joomla
 * @subpackage	LetsForms
 * @since 1.0
 */
class letsformsViewmembers extends JView
{
	function display($tpl = null)
	{
		$layout     = JRequest::getCmd('layout');
		$itemid     = JRequest::getCmd('Itemid');
		
		if($layout == 'list') {
			$user =& JFactory::getUser();
			$model =&$this->getModel();
			
			$members = $model->getMembers();
				
			$this->assignRef('username', $user->name);
			$this->assignRef('members', $members);
		}
		else if($layout == 'adddirentry') {
			$user =& JFactory::getUser();
			$model =&$this->getModel();
			$params = &JComponentHelper::getParams('com_letsforms');
			
			$members = $model->getMembers();
			$categories = $model->getCategories();
			
			$memberNo = JRequest::getVar('member');
			$categoryId = JRequest::getVar('category');
			$type = JRequest::getVar('type');
			$description = JRequest::getVar('description');
			$rate = JRequest::getVar('rate');
			$accessLevel = JRequest::getVar('accessLevel');
			$errmsg = JRequest::getVar('errmsg');
			$mode = JRequest::getVar('mode');
			
			if($mode == 'edit') {
				$direntryId = JRequest::getVar('dirId');
				$direntry = $model->getDirectoryEntry($direntryId);
			}
			else {
				$direntry['categoryId'] = $categoryId;
				$direntry['type'] = $type;
				$direntry['description'] = $description;
				$direntry['rate'] = $rate;
			}
			
			if(empty($memberNo)) {
				$memberNo = $model->getMemberNoFromUserId($user->id);
			}
			
			if(empty($accessLevel)) {
				$accessLevel = $params->get('adeaccesslevel');
			}
			
			//var_dump($direntryId);
			//var_dump($direntry);
			
			$this->assignRef('members', $members);
			$this->assignRef('categories', $categories);
			$this->assignRef('accessLevel', $accessLevel);
			$this->assignRef('memberNo', $memberNo);
			$this->assignRef('errmsg', $errmsg);
			$this->assignRef('mode', $mode);
			$this->assignRef('direntry', $direntry);
			
		}
		else if($layout == 'confirmade') {
			$model =&$this->getModel();
			
			$categoryId = JRequest::getVar('category');
			$memberNo = JRequest::getVar('member');
			
			$categoryName = $model->getCategoryName($categoryId);
			$memberName = $model->getNameFromMemberNo($memberNo);
			
			$this->assignRef('categoryName', $categoryName);
			$this->assignRef('memberName', $memberName);
			$this->assignRef('type', JRequest::getVar('offerorwant'));
			$this->assignRef('description', JRequest::getVar('description'));
			$this->assignRef('rate', JRequest::getVar('rate'));
		}
		else if($layout == 'directorysearch') {
			$params = &JComponentHelper::getParams('com_letsforms');
			$model =&$this->getModel();
			
			$categories = $model->getCategories();
			$offerorwant = $params->get('offerorwant');
			
			$firsttime = JRequest::getVar('firsttime');
			if(empty($firsttime)) {
				$firsttime = 'true';
			}
			else {
				$categoryId = JRequest::getVar('category');
				$offerorwant = JRequest::getVar('offerorwant');
				$description = JRequest::getVar('description');
				$period = JRequest::getVar('period');
				
				$direntries = $model->getMatchingDirectoryEntries($categoryId, $offerorwant, $description, $period);
			}
			
			$this->assignRef('categories', $categories);
			$this->assignRef('type', $offerorwant);
			$this->assignRef('firsttime', $firsttime);
			$this->assignRef('direntries', $direntries);
			$this->assignRef('categoryId', $categoryId);
			$this->assignRef('description', $description);
			$this->assignRef('period', $period);
		}
		else if($layout == 'viewmember') {
			$model =&$this->getModel();
			
			$memberNo = JRequest::getVar('memberNo');
			$member = $model->getMemberDetails($memberNo);
			$offers = $model->getMemberEntries($memberNo, 'Offer');
			$wants = $model->getMemberEntries($memberNo, 'Want');
			$emails = $model->getUserEmails($memberNo);
			
			if(!empty($emails)) {
				$len = count($emails);
				$i = 1;
				foreach($emails as $email) {
					$emailstr = $emailstr . $email['email'];
					if($i < $len) {
						$emailstr = $emailstr . '; ';
					} 
					$i++;				
				}
				
				$member['email'] = $emailstr;
			}
			
			$this->assignRef('member', $member);
			$this->assignRef('offers', $offers);
			$this->assignRef('wants', $wants);
		}
		else if($layout == 'editmember') {
			$user =& JFactory::getUser();
			$model =&$this->getModel();
			
			$errmsg = JRequest::getVar('errmsg');
			
			$memberNo = JRequest::getVar('memberNo');
			if(empty($memberNo)) {
				$memberNo = $model->getMemberNoFromUserId($user->id);
			}
			
			$member = $model->getMemberDetails($memberNo);
			$member['email'] = $user->email;
			
			$this->assignRef('errmsg', $errmsg);
			$this->assignRef('username', $user->username);
			$this->assignRef('member', $member);
		}
		else if($layout == 'confirmedit') {
			$user =& JFactory::getUser();
			$model =&$this->getModel();
			
			$memberNo = JRequest::getVar('memberNo');
			if(empty($memberNo)) {
				$memberNo = $model->getMemberNoFromUserId($user->id);
			}
			
			$member = $model->getMemberDetails($memberNo);
			$member['email'] = $user->email;
			
			$this->assignRef('username', $user->username);
			$this->assignRef('member', $member);
		}
		else if($layout == 'editdirentries') {
			$user =& JFactory::getUser();
			$model =&$this->getModel();
			$params = &JComponentHelper::getParams('com_letsforms');
			
			$type = JRequest::getVar('type');
			if(empty($type)) {
				$type = $params->get('entrytype');
			}
			
			$errmsg = JRequest::getVar('errmsg');
			$infomsg = JRequest::getVar('infomsg');
			
			$memberNo = JRequest::getVar('memberNo');
			if(empty($memberNo)) {
				$memberNo = $model->getMemberNoFromUserId($user->id);
			}
			
			$type = ucwords($type);
			$entries = $model->getMemberEntries($memberNo, $type);
			
			$this->assignRef('type', $type);
			$this->assignRef('errmsg', $errmsg);
			$this->assignRef('infomsg', $infomsg);
			$this->assignRef('memberNo', $memberNo);
			$this->assignRef('direntries', $entries);
		}
		else if($layout == 'confirmdelentries') {
			$user =& JFactory::getUser();
			$model =&$this->getModel();
			
			$type = JRequest::getVar('type');
			$errmsg = JRequest::getVar('errmsg');
			$memberNo = JRequest::getVar('memberNo');
			$selected = JRequest::getVar('selected');
			
			$entries = $model->getSelectedEntries($selected);
			
			$this->assignRef('type', $type);
			$this->assignRef('errmsg', $errmsg);
			$this->assignRef('memberNo', $memberNo);
			$this->assignRef('direntries', $entries);
		}
		else if($layout == 'changepasswd') {
			$errmsg = JRequest::getVar('errmsg');
			$this->assignRef('errmsg', $errmsg);
		}
		else if($layout == 'success') {
			$infomsg = JRequest::getVar('infomsg');
			$this->assignRef('infomsg', $infomsg);
		}
		else if($layout == 'mailmembers') {
			$errmsg = JRequest::getVar('errmsg');
			$subject = JRequest::getVar('subject');
			$body = JRequest::getVar('body');
			
			$this->assignRef('errmsg', $errmsg);
			$this->assignRef('subject', $subject);
			$this->assignRef('body', $body);
		}
		
		$this->assignRef('Itemid', $itemid);
		parent::display($tpl);
	}

}
